///
/// Solid State by HTML5 UP
/// html5up.net | @ajlkn
/// Free for personal and commercial use under the CCA 3.0 license (html5up.net/license)
///
/*
 * Presenter Club - Make Great Presentations, Faster
 * Copyright (C) 2016 Sam Parkinson <sam@sam.today>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


/* Wrapper */

/// Sets the colors of the wrapper's top/bottom edges.
/// @param {string} $color Color.
@mixin wrapper-edges-color($color: black) {
    &:before, &:after {
        background-image: svg-url('<svg xmlns="http://www.w3.org/2000/svg" width="100" height="100" viewBox="0 0 100 100" preserveAspectRatio="none"><polygon points="0,100 100,0 100,100" style="fill:#{$color};" /></svg>');
    }
}

#wrapper {
    > header {
            @include padding(7.5em, 0, (3.5em, 0, _size(wrapper-edges, large) * -0.5, 0));

            .inner {
                    margin: 0 auto;
                    width: _size(inner);
                    max-width: 100%;
            }

            h2 {
                    border-bottom: solid 2px _palette(border);
                    font-size: 2em;
                    margin-bottom: _size(element-margin) * 0.4;
                    padding-bottom: _size(element-margin) * 0.2;
            }

            p {
                    font-family: _font(family-heading);
                    font-size: 1em;
                    font-weight: _font(weight-heading);
                    letter-spacing: _font(kern-heading);
                    line-height: 2;
                    text-transform: uppercase;
            }
    }

    @include breakpoint(large) {
            > header {
                    @include padding(5em, 0, (4em, 0, _size(wrapper-edges, large) * 0.5, 0));

                    background-color:		_palette(wrapper-color);

                    background-image:		linear-gradient(to top, transparentize(_palette(wrapper-color), 0.2), transparentize(_palette(wrapper-color), 0.2)),
                                                                    url('https://images.unsplash.com/photo-1459749411175-04bf5292ceea?ixlib=rb-0.3.5&q=80&fm=jpg&crop=entropy&w=1080&fit=max&s=41d75dbe679b397b130ad985acd16b18');

                    background-size:		auto,
                                                                    cover;

                    background-position:	center,
                                                                    0% 30%;

                    margin-bottom: (_size(wrapper-edges, large) * -1);
            }
    }

    @include breakpoint(medium) {
            > header {
                    @include padding(7em, 3em, (4em, 0, _size(wrapper-edges, medium) * 0.5, 0));

                    background-size:		auto,
                                                                    cover;

                    background-position:	center,
                                                                    0% 0%;

                    margin-bottom: (_size(wrapper-edges, medium) * -1);

                    .inner {
                            width: 100%;
                    }
            }
    }

    @include breakpoint(small) {
            > header {
                    @include padding(3.75em, 2em, (2.75em, 0, _size(wrapper-edges, small) * 0.5, 0));

                    background-size:		auto,
                                                                    125%;

                    margin-bottom: (_size(wrapper-edges, small) * -1);

                    h2 {
                            font-size: 1.25em;
                    }

                    p {
                            font-size: 0.8em;
                    }
            }
    }
}

.wrapper {
    .inner {
        @include padding(3em, 0);
        margin: 0 auto;
        width: _size(inner);
        max-width: 100%;
    }

    @for $i from 2 through _misc(max-wrapper-styles) {
        $j: 3 * ($i - 1);
        $color: desaturate(lighten(_palette(wrapper-color), $j), $j * 0.5);

        &.style#{$i} {
            background-color: $color;
            @include wrapper-edges-color($color);
        }
    }

    &.spotlight {
        margin: _size(wrapper-edges, large) 0;
        position: relative;

        background-color: _palette(wrapper-color);
        @include wrapper-edges-color(_palette(wrapper-color));
        &:before, &:after {
            background-repeat: no-repeat;
            background-size: 100% 100%;
            content: '';
            display: block;
            height: _size(wrapper-edges, large);
            position: absolute;
            width: 100%;
        }

        &:before {
            left: 0;
            top: (_size(wrapper-edges, large) * -1);
        }

        &:after {
            @include vendor('transform', 'scaleY(-1)');
            bottom: (_size(wrapper-edges, large) * -1);
            left: 0;
        }

        &.alt {
            &:before {
                @include vendor('transform', 'scaleX(-1)');
            }

            &:after {
                @include vendor('transform', 'scaleY(-1) scaleX(-1)');
            }
        }

        .inner {
            @include vendor('display', 'flex');
            @include vendor('align-items', 'center');
            @include vendor('flex-direction', 'row');
        }

        .image {
            width: 22em;
            overflow: hidden;
            -ms-flex: 1;
        }

        .content {
            width: 100%;
            -ms-flex: 2;
        }

        &:nth-child(2n - 1):not(.force-left) {
            .inner {
                flex-direction: row-reverse;
                text-align: right;
            }
        }

        @for $i from 2 through _misc(max-wrapper-styles) {
            $j: 3 * ($i - 1);
            $color: saturate(darken(_palette(wrapper-color), $j), $j * 0.5);

            &.style#{$i} {
                background-color: $color;
                @include wrapper-edges-color($color);
            }
        }
    }

    @include breakpoint(medium) {
        //margin: _size(wrapper-edges, medium) 0;

        &:before, &:after {
            height: _size(wrapper-edges, medium);
        }

        &:before {
            top: (_size(wrapper-edges, medium) * -1);
        }

        &:after {
            bottom: (_size(wrapper-edges, medium) * -1);
            left: 0;
        }

        .inner {
            @include padding(3em, 3em);
            width: 100%;
        }

        &.spotlight {
            .image {
                width: 32em;
            }
        }
    }

    @include breakpoint(small) {
        //margin: _size(wrapper-edges, small) 0;

        &:before, &:after {
            height: _size(wrapper-edges, small);
        }

        &:before {
            top: (_size(wrapper-edges, small) * -1);
        }

        &:after {
            bottom: (_size(wrapper-edges, small) * -1);
            left: 0;
        }

        .inner {
            @include padding(2em, 2em);
        }

        &.spotlight {
            .inner {
                @include vendor('align-items', 'flex-start');
            }

            .image {
                width: 19em;
            }
        }
    }

    @include breakpoint(xsmall) {
        &.spotlight {
            .inner {
                display: block;
            }

            .image {
                max-width: 85%;
                width: 12em;
            }
        }
    }

    @include breakpoint(xxsmall) {
        .inner {
            @include padding(2em, 1.5em);
        }
    }
}
